using System;
using System.Collections.Generic;
using System.Text;

namespace Sketcher
{
    class FadeInOutBehavior : RenderableTransitionBehavior
    {
        float m_fFadeTime;
        Animation m_fade;

        public FadeInOutBehavior(Renderable target)
            : base(target) {
//            m_fFadeTime = 0.15f;
            m_fFadeTime = 0.5f;
            m_fade = null;
        }

        public float FadeTime {
            get { return m_fFadeTime; }
            set { m_fFadeTime = value; }
        }

        override public void OnShow() {
            RTarget.Visibility = VisibilityState.TransitioningToVisible;

            m_fade = new FadeAnimation(RTarget, FadeAnimation.FadeType.FadeIn, FadeTime);
            m_fade.AnimationFinishedEvent += new Animation.AnimationFinishedHandler(OnShowFinishedCallback);

            AnimationManager.Get.AnimateOnce(m_fade);
        }
        override public void OnShowFinished() {
            RTarget.Visibility = VisibilityState.Visible;
            m_fade = null;
        }
        protected void OnShowFinishedCallback(object o) {
            OnShowFinished();
        }

        override public void OnHide() {
            RTarget.Visibility = VisibilityState.TransitioningToHidden;

            m_fade = new FadeAnimation(RTarget, FadeAnimation.FadeType.FadeOut, FadeTime);
            m_fade.AnimationFinishedEvent += new Animation.AnimationFinishedHandler(OnHideFinishedCallback);

            AnimationManager.Get.AnimateOnce(m_fade);
        }
        override public void OnHideFinished() {
            RTarget.Visibility = VisibilityState.Hidden;
            m_fade = null;
        }
        protected void OnHideFinishedCallback(object o) {
            OnHideFinished();
        }

        override public void Stop() {
            if ( m_fade != null )
                AnimationManager.Get.StopAnimation(m_fade);
        }

    }
}
