using System;
using System.Collections.Generic;
using System.Text;

namespace Sketcher
{
    //! this class prevents input from being captured if first point is inside Element bounds
    class PreventCaptureBehavior : ElementInputBehavior
    {
        public PreventCaptureBehavior(Element target) : base(target) {
        }

        override public InputCaptureType CaptureType {
            get { return InputCaptureType.MayCapture; }
        }

        //! return value in [0,1] to indicate desire for capturing stroke
        override public float GetCaptureScore(Stroke s) {
            if ( TargetElement.Bounds.Contains(s[s.Count - 1]))
                return InputBehavior.PREVENT_CAPTURE;
            return 0.0f;
        }
    }
}
