using System;
using System.Collections.Generic;
using System.Text;

namespace Sketcher
{
    abstract class TransitionBehavior : Behavior
    {
        public TransitionBehavior(Object target) : base(target) 
        {
            Connect();
        }

        //! connect this behavior to the world
        override public void Connect() {
            TransitionBehaviorManager.Get.Register(this);
        }

        //! disconnect this behavior from the world
        override public void Disconnect( ) {
            TransitionBehaviorManager.Get.DeRegister( this );
        }

        virtual public void OnShow() {
        }
        virtual public void OnShowFinished() {
        }

        virtual public void OnHide() {
        }
        virtual public void OnHideFinished() {
        }

        virtual public void Stop() {
        }
    }


    /*
     * "versions" of class with different types of target
     */

    abstract class RenderableTransitionBehavior : TransitionBehavior
    {
        public RenderableTransitionBehavior(Renderable target)
            : base(target) {
        }

        public Renderable RTarget {
            get { return (Renderable)Target; }
        }
    }

}