using System;
using System.Collections.Generic;
using System.Text;

namespace Sketcher
{
    class AnimationBehaviorManager
    {
        List<AnimationBehavior> m_targets;

        public void Register(AnimationBehavior behavior) {
            if ( ! m_targets.Contains(behavior) )
                m_targets.Add(behavior);
        }
        public void DeRegister(AnimationBehavior behavior) {
            m_targets.Remove(behavior);
        }

        public void StartAnimation( BehaviorTarget target, AnimationBehavior behavior ) {
            if ( target.Behaviors.AnimationBehaviors.Contains(behavior) )
                behavior.OnStart();
        }

        public void StopAnimation( BehaviorTarget target, AnimationBehavior behavior ) {
            if ( target.Behaviors.AnimationBehaviors.Contains(behavior) )
                behavior.OnStop();
        }

        static public AnimationBehaviorManager Get {
            get {
                if (s_singleton == null)
                    s_singleton = new AnimationBehaviorManager();
                return s_singleton;
            }
        }

        protected AnimationBehaviorManager() {
            m_targets = new List<AnimationBehavior>();
        }
        static AnimationBehaviorManager s_singleton = null;
    }
}


