using System;
using System.Collections.Generic;
using System.Text;
using Tao.OpenGl;

namespace Sketcher
{
    class IconItem : Item
    {
        public IconItem(Size2f size, ColorRGBA bgcolor) {
            BackgroundColor = bgcolor;

            this.Behaviors.Add(new ToggleBGColorOnCircleBehavior(this));
            this.Behaviors.Add(new RadialPopUpMenuOnCrossBehavior(this));

            Resize(size.ToBox());
        }

        //! draw object
        override public void Render() {
            Box2f bounds = new Box2f(Bounds);
            bounds.Expand(-2);
            RenderEngine.Get.DrawBox(bounds, BackgroundColor);
        }

    }
}
