using System;
using System.Collections.Generic;
using System.Text;

namespace Sketcher
{
    class TitlebarItem : Item
    {
        protected string m_text;

        public TitlebarItem(Size2f size, string text) {
            m_text = text;
            BackgroundColor = new ColorRGBA(0.4f, 0.4f, 1.0f);
            ForegroundColor = ColorRGBA.WHITE;

            Resize(size.ToBox());
        }

        //! draw object
        override public void Render() {
            RenderEngine.Get.DrawBox(this.Bounds, BackgroundColor);
            RenderEngine.Get.DrawText(m_text, Bounds.Min, ForegroundColor);
        }

        override public bool CanResizeHeight {
            get { return false; }
        }

    }
}
