using System;
using System.Collections.Generic;
using System.Text;

namespace Sketcher
{
    class FixedRectContainer : Container
    {
        float m_fChildAreaBoarder;

        public FixedRectContainer(Box2f bounds, Layout layout) : base(layout) {
            Resize(bounds);

            m_fChildAreaBoarder = 5.0f;
            ForegroundColor = ColorRGBA.RED;
            BackgroundColor = ColorRGBA.WHITE;
        }

        public float ChildAreaBorder {
            get { return m_fChildAreaBoarder; }
            set { m_fChildAreaBoarder = value; }
        }


#region Item Overrides

 
        override public void Render() {
            ValidateLayout();

            // [RMS] need to implement thickness for DrawBoxOutline
            //RenderEngine.Get.DrawBox( Bounds, AlphaBackgroundColor);
            //RenderEngine.Get.DrawBoxOutline( Bounds, AlphaForegroundColor );
            RenderEngine.Get.DrawBox( Bounds, AlphaForegroundColor);
            RenderEngine.Get.DrawBoxOutline( ChildAreaBounds, AlphaBackgroundColor );


            // set clip region for child
            RenderEngine.Get.PushClipBox(ChildAreaBounds);

            for (int i = 0; i < Items.Count; ++i) {
                if ( Element.VisibleForRendering( Items[i].Visibility ) )
                    Items[i].Render();
            }

            RenderEngine.Get.PopClipBox();
        }
#endregion




#region Container Overrides

        override protected Box2f GetChildAreaRegion() {
            float fPad = m_fChildAreaBoarder;
            Box2f tmp = Bounds;
            tmp.Pad(fPad, -fPad, fPad, -fPad);
            return tmp;
        }


/*
        void UpdateChildAreaBounds() {
            m_itemarea = m_bounds;
            m_itemarea.Expand(-3);
            m_layout.InvalidateLayout();
            NotifyItemChanged();
        }
 */
#endregion


    }

}
