using System;
using System.Collections.Generic;
using System.Text;

namespace Sketcher
{
    class InfiniteRectContainer : Container
    {

        public InfiniteRectContainer(Box2f bounds, Layout layout) : base(layout) {
            Resize(bounds);

            ForegroundColor = ColorRGBA.WHITE;
            BackgroundColor = ColorRGBA.BLACK;
        }


#region Item Overrides

        override public void Render() {
            ValidateLayout();
            
            RenderEngine.Get.DrawBox(Bounds, AlphaBackgroundColor);
            RenderEngine.Get.DrawBox(ChildAreaBounds, AlphaForegroundColor );

            // set clip region for child
            RenderEngine.Get.PushClipBox(ChildAreaBounds);

            for (int i = 0; i < Items.Count; ++i) {
                if (Element.VisibleForRendering(Items[i].Visibility))
                    Items[i].RenderBackground();
            }

            for (int i = 0; i < Items.Count; ++i) {
                if (Element.VisibleForRendering(Items[i].Visibility))
                    Items[i].Render();
            }

            RenderEngine.Get.PopClipBox();
        }
#endregion




#region Container Overrides

        override protected Box2f GetChildAreaRegion() {
            float fPad = 5;
            Box2f tmp = Bounds;
            tmp.Pad(fPad, -fPad, fPad, -fPad);
            return tmp;
        }

#endregion


    }

}
