using System;
using System.Collections.Generic;
using System.Text;

namespace Sketcher
{
    class FadeToGrayAnimation : Animation
    {
        float m_fCycleDelta;
        ColorRGBA m_cOriginalColor;

        public FadeToGrayAnimation( Renderable target, float fDuration, float fCycleDelta ) : base(target, fDuration)
        {
            m_fDuration = fDuration;
            m_fCycleDelta = fCycleDelta;
            m_cOriginalColor = target.BackgroundColor;
        }

        public ColorRGBA OriginalColor {
            get { return m_cOriginalColor; }
        }

        //! animation action
        override protected void OnTimeUpdated() {
            int nCycle = (int)( TimeElapsed / m_fCycleDelta );
            float fTime = TimeElapsed - (float)nCycle * m_fCycleDelta;
            float fDelta = fTime / m_fCycleDelta;

            // [RMS] this is very hacky...
            fDelta = (fDelta - 0.5f) * 2.0f;
            if ( fDelta < 0 ) {
                // to gray
                fDelta = 1.0f - Math.Abs(fDelta);
                fDelta = 1.0f - fDelta*fDelta;
                fDelta = fDelta * fDelta * fDelta;
                fDelta = 1.0f - fDelta;
            } else {
                // from gray
                fDelta = 1 - fDelta;
                fDelta = 1.0f - fDelta*fDelta;
                fDelta = fDelta * fDelta * fDelta;
                fDelta = 1.0f - fDelta;
            }

            ColorRGBA color = m_cOriginalColor;
            //ColorRGBA gray = m_cOriginalColor.ToGrayscale();
            ColorRGBA gray = ColorRGBA.WHITE;
            ColorRGBA interp = ColorRGBA.Interpolate( color, gray, fDelta );
            
            Target.BackgroundColor = interp;
        }
    }
}
